# Parsec Cloud (https://parsec.cloud) Copyright (c) BUSL-1.1 2016-present Scille SAS

# /!\ Autogenerated by misc/gen_protocol_typings.py, any modification will be lost !

from __future__ import annotations

from parsec._parsec import DateTime, HumanHandle, UserID

class InvitationType:
    pass

class InvitationTypeUser(InvitationType):
    def __init__(
        self,
        claimer_email: str,
        created_by: InvitationCreatedBy,
        administrators: list[UserGreetingAdministrator],
    ) -> None: ...
    @property
    def administrators(self) -> list[UserGreetingAdministrator]: ...
    @property
    def claimer_email(self) -> str: ...
    @property
    def created_by(self) -> InvitationCreatedBy: ...

class InvitationTypeDevice(InvitationType):
    def __init__(
        self,
        claimer_user_id: UserID,
        claimer_human_handle: HumanHandle,
        created_by: InvitationCreatedBy,
    ) -> None: ...
    @property
    def claimer_human_handle(self) -> HumanHandle: ...
    @property
    def claimer_user_id(self) -> UserID: ...
    @property
    def created_by(self) -> InvitationCreatedBy: ...

class InvitationTypeShamirRecovery(InvitationType):
    def __init__(
        self,
        claimer_user_id: UserID,
        claimer_human_handle: HumanHandle,
        created_by: InvitationCreatedBy,
        shamir_recovery_created_on: DateTime,
        threshold: int,
        recipients: list[ShamirRecoveryRecipient],
    ) -> None: ...
    @property
    def claimer_human_handle(self) -> HumanHandle: ...
    @property
    def claimer_user_id(self) -> UserID: ...
    @property
    def created_by(self) -> InvitationCreatedBy: ...
    @property
    def recipients(self) -> list[ShamirRecoveryRecipient]: ...
    @property
    def shamir_recovery_created_on(self) -> DateTime: ...
    @property
    def threshold(self) -> int: ...

class UserOnlineStatus:
    VALUES: tuple[UserOnlineStatus]
    ONLINE: UserOnlineStatus
    OFFLINE: UserOnlineStatus
    UNKNOWN: UserOnlineStatus

    @classmethod
    def from_str(cls, value: str) -> UserOnlineStatus: ...
    @property
    def str(self) -> str: ...

class InvitationCreatedBy:
    pass

class InvitationCreatedByUser(InvitationCreatedBy):
    def __init__(self, user_id: UserID, human_handle: HumanHandle) -> None: ...
    @property
    def human_handle(self) -> HumanHandle: ...
    @property
    def user_id(self) -> UserID: ...

class InvitationCreatedByExternalService(InvitationCreatedBy):
    def __init__(self, service_label: str) -> None: ...
    @property
    def service_label(self) -> str: ...

class UserGreetingAdministrator:
    def __init__(
        self,
        user_id: UserID,
        human_handle: HumanHandle,
        online_status: UserOnlineStatus,
        last_greeting_attempt_joined_on: DateTime | None,
    ) -> None: ...
    @property
    def human_handle(self) -> HumanHandle: ...
    @property
    def last_greeting_attempt_joined_on(self) -> DateTime | None: ...
    @property
    def online_status(self) -> UserOnlineStatus: ...
    @property
    def user_id(self) -> UserID: ...

class ShamirRecoveryRecipient:
    def __init__(
        self,
        user_id: UserID,
        human_handle: HumanHandle,
        shares: int,
        revoked_on: DateTime | None,
        online_status: UserOnlineStatus,
    ) -> None: ...
    @property
    def human_handle(self) -> HumanHandle: ...
    @property
    def online_status(self) -> UserOnlineStatus: ...
    @property
    def revoked_on(self) -> DateTime | None: ...
    @property
    def shares(self) -> int: ...
    @property
    def user_id(self) -> UserID: ...

class Req:
    def __init__(
        self,
    ) -> None: ...
    def dump(self) -> bytes: ...

class Rep:
    @staticmethod
    def load(raw: bytes) -> Rep: ...
    def dump(self) -> bytes: ...

class RepUnknownStatus(Rep):
    def __init__(self, status: str, reason: str | None) -> None: ...
    @property
    def status(self) -> str: ...
    @property
    def reason(self) -> str | None: ...

class RepOk(Rep):
    def __init__(self, unit: InvitationType) -> None: ...
    @property
    def unit(self) -> InvitationType: ...
